#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>

/*
    Method for calculating length of optimal paths
    Input variables:
        - char dir[]:   File directory
        - int Ngrid:    Dimension of grid (NxN)
        - int mi:       Which "minimumvalues_.dat to be read
        - int startx:   X value for one of the path ends
        - int starty:   Y value for the same path end

    Return variable:
        - double:   totdist = Total length of input path

    Other output:
        - FILE "sorted_minpath_.dat  containing the sorted list of points in optimal path
*/


double calc_pathlength(char directory[], int Ngrid, int mi) {

    printf("\n Calculating pathlength \n");

    char dir[150];

    sprintf(dir, directory);

//------------------------------------------------------------------------------------------------------
    // Create and open file in given directory

    char nPo[200];

    sprintf(nPo, "%s%s", dir, "\\number_val.dat");

    FILE *nPoints = fopen(nPo, "r");   // Number of points in optimal path

//-----------------------------------------------------------------------------------------------------


    int N;    // Number of points in path
    fscanf(nPoints, "%i", &N);
    fclose(nPoints);

    double totdist = 0.0;

    if(N > 1)
        totdist = (double)(N-1);
    else
        totdist = 0.0001;
    return totdist;
}
